#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "main.h"

unsigned sleep(unsigned seconds);

extern int allpid[BUS_NB+3];

void traitant(int num)
{
  signal(SIGUSR1, traitant);
}

void perturbateur(void)
{
  sigset_t ens;

  srand(getpid());

  sigemptyset(&ens);
  sigaddset(&ens, SIGUSR1);
  sigprocmask(SIG_SETMASK, &ens, NULL);
  sigemptyset(&ens);

  signal(SIGUSR1, traitant);

  while(1)
    {
      int temps, i, n;
      sleep(RAND(20.0));

      temps = RAND(4.0);
      n     = RAND(((float)BUS_NB));

      for (i = 0; i < temps; i++)
	{
	  kill(allpid[n], SIGUSR1);
	  sigsuspend(&ens);
	}
    }

}
